function varargout = cftGUI(varargin)
% CFTGUI MATLAB code for cftGUI.fig
%      CFTGUI, by itself, creates a new CFTGUI or raises the existing
%      singleton*.
%
%      H = CFTGUI returns the handle to a new CFTGUI or the handle to
%      the existing singleton*.
%
%      CFTGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CFTGUI.M with the given input arguments.
%
%      CFTGUI('Property','Value',...) creates a new CFTGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before cftGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to cftGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help cftGUI

% Last Modified by GUIDE v2.5 29-Jan-2017 17:18:22

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @cftGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @cftGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before cftGUI is made visible.
function cftGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to cftGUI (see VARARGIN)

% get file names for images used to create composite faces
handles.fnames = dir('Lab2_files/FaceParts/*.png');
handles.fnames = handles.fnames([4 15 17:23 5:14 16 24 35 37:43 25:34 36 44 ...
                                 55 57:63 45:54 56 64 75 77:34 77:83 65:74 76]-3);    
% store indices for top and bottom half-images for first and second face
% images, and the alignment and same/different conditions, for each trial
[handles.tops1, handles.bots1, handles.tops2, handles.bots2, handles.alignment, handles.sameDiff] = expFaces();
handles.trialOrder = randperm(80);      % random ordering of conditions
handles.cross = zeros(256,256);         % image of fixation cross
handles.cross(121:136,128:130) = 1;
handles.cross(128:130,121:136) = 1;
imshow(handles.cross, [])
handles.trialNum = 1;                   % increments on each trial
handles.totalTrials = 80;
handles.results = zeros(1,80);          % stores subject responses
set(handles.sameButton, 'Enable', 'off');
set(handles.diffButton, 'Enable', 'off');
% Choose default command line output for cftGUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes cftGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = cftGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in nextButton.
function nextButton_Callback(hObject, eventdata, handles)
% hObject    handle to nextButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.orientMenu, 'Enable', 'off')    % disable orientation menu
trial = handles.trialOrder(handles.trialNum);   % get condition number
top1 = handles.tops1(trial);        % get indices for top and bottom faces
top2 = handles.tops2(trial);        % for the two images for this trial
bot1 = handles.bots1(trial);
bot2 = handles.bots2(trial);
% read in the four component images (top/bottom for two images)
im1 = imread(strcat('FaceParts/', handles.fnames(top1).name));
im2 = imread(strcat('FaceParts/', handles.fnames(top2).name));
imbot1 = imread(strcat('FaceParts/', handles.fnames(bot1).name));
imbot2 = imread(strcat('FaceParts/', handles.fnames(bot2).name));
if handles.alignment(trial)     % make image with top and bottom aligned
    im1(129:256,:) = imbot1(129:256,:);
    im2(129:256,:) = imbot2(129:256,:);
else                            % make image with top and bottom misaligned
    im1(129:256,31:256) = imbot1(129:256,1:226);
    im2(129:256,31:256) = imbot2(129:256,1:226);
end
im1(128,:) = 0;     % add dark horizontal line
im2(128,:) = 0;
pause(0.4)
if (get(handles.orientMenu, 'Value') == 1)   % display im1 in upright view
    imshow(im1,[])
else                                    % display im1 in upside-down view
    imshow(im1(256:-1:1,:),[])
end
pause(0.5)
imshow(handles.cross,[])                % show fixation cross
pause(0.5)
if (get(handles.orientMenu, 'Value') == 1)   % display im2 in upright view
    imshow(im2,[])
else                                    % display im2 in upside-down view
    imshow(im2(256:-1:1,:),[])
end
pause(0.5)
imshow(handles.cross,[])                % show fixation cross
set(handles.sameButton, 'Enable', 'on')
set(handles.diffButton, 'Enable', 'on')
set(handles.nextButton, 'Enable', 'off')
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in sameButton.
function sameButton_Callback(hObject, eventdata, handles)
% hObject    handle to sameButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.results(handles.trialNum) = 1;
set(handles.sameButton, 'Enable', 'off')
set(handles.diffButton, 'Enable', 'off')
handles.trialNum = 1 + handles.trialNum;
if (handles.trialNum < handles.totalTrials)
    set(handles.nextButton, 'Enable', 'on')
else
    recordData(handles.trialOrder, handles.results, handles.alignment, ...
                handles.sameDiff, handles.totalTrials, get(handles.orientMenu, 'Value'));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in diffButton.
function diffButton_Callback(hObject, eventdata, handles)
% hObject    handle to diffButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.results(handles.trialNum) = 0;
set(handles.sameButton, 'Enable', 'off')
set(handles.diffButton, 'Enable', 'off')
handles.trialNum = 1 + handles.trialNum;
if (handles.trialNum <= handles.totalTrials)
    set(handles.nextButton, 'Enable', 'on')
else
    recordData(handles.trialOrder, handles.results, handles.alignment, ...
                handles.sameDiff, handles.totalTrials, get(handles.orientMenu, 'Value'));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in closeButton.
function closeButton_Callback(hObject, eventdata, handles)
% hObject    handle to closeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
delete(handles.figure1)

% --- Executes on selection change in orientMenu.
function orientMenu_Callback(hObject, eventdata, handles)
% hObject    handle to orientMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns orientMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from orientMenu

% --- Executes during object creation, after setting all properties.
function orientMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to orientMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
