function [tops1, bots1, tops2, bots2, alignment, sameDiff] = expFaces()
% assumes experiment has 80 trials, all run upright or all upside-down
% tops1 is vector of 80 indices for top halves of image1 (41-80)
% bots1 is vector of 80 indices for bottom halves of image1 (1-40)
% tops2 is vector of 80 indices for top halves of image2 (41-80)
% bots2 is vector of 80 indices for bottom halves of image2 (1-40)
% alignment is vector of length 80 containing 0 (misalign) or 1 (align)
% sameDiff is vector of length 80 containing 0 (different) or 1 (same)
% indices refer to 80 images in FaceParts folder - tops have indices 41-80
% and bottoms have indices 1-40

alignment = [zeros(1,40) ones(1,40)];
sameDiff = [ones(1,20) zeros(1,20) ones(1,20) zeros(1,20)];
tops1 = [41:50   61:70    51:60    71:80    41:50   61:70    51:60     71:80];    
tops2 = [41:50   61:70    60:-1:51 80:-1:71 41:50   61:70    60:-1:51  80:-1:71]; 
bots1 = [ 1:10   21:30    11:20    31:40    1:10    21:30    11:20     31:40];
bots2 = [10:-1:1 30:-1:21 20:-1:11 40:-1:31 10:-1:1 30:-1:21 20:-1:11  40:-1:31];

